import * as React from 'react';
export declare type ErrorCallback = (error: Error | FetchError) => void;
export declare type LoadCallback = (src: string, isCached: boolean) => void;
export declare type PlainObject<T = unknown> = Record<string | number | symbol, T>;
export declare type PreProcessorCallback = (code: string) => string;
export interface Props extends Omit<React.SVGProps<SVGElement>, 'onLoad' | 'onError' | 'ref'> {
    baseURL?: string;
    cacheRequests?: boolean;
    children?: React.ReactNode;
    description?: string;
    fetchOptions?: RequestInit;
    innerRef?: React.Ref<SVGElement>;
    loader?: React.ReactNode;
    onError?: ErrorCallback;
    onLoad?: LoadCallback;
    preProcessor?: PreProcessorCallback;
    src: string;
    title?: string;
    uniqueHash?: string;
    uniquifyIDs?: boolean;
}
export interface State {
    content: string;
    element: React.ReactNode;
    hasCache: boolean;
    status: string;
}
export interface FetchError extends Error {
    code: string;
    errno: string;
    message: string;
    type: string;
}
export interface StorageItem {
    content: string;
    status: string;
}
